package org.xdoclet.plugin.web.qtags;

public class JspTagTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.web.qtags.JspTagTag {
    public static final String NAME = "jsp.tag";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"name",
		"class",
		"tei-class",
		"body-content",
		"display-name",
		"small-icon",
		"large-icon",
		"description",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public JspTagTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public JspTagTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getName_() {
		boolean required = true;
        String result = getNamedParameter("name");
        if(required && result == null) {
            bomb("name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getClass_() {
		boolean required = false;
        String result = getNamedParameter("class");
        if(required && result == null) {
            bomb("class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTeiClass() {
		boolean required = false;
        String result = getNamedParameter("tei-class");
        if(required && result == null) {
            bomb("tei-class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getBodyContent() {
		boolean required = false;
        String result = getNamedParameter("body-content");
        if(required && result == null) {
            bomb("body-content=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "JSP";
        }

		if (result != null) {
	            if( !(false || result.equals("tagdependent")|| result.equals("JSP")|| result.equals("empty")|| result.equals("scriptless")) ) {
	                // todo we should say what file and line number too
	                bomb("body-content=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisplayName() {
		boolean required = false;
        String result = getNamedParameter("display-name");
        if(required && result == null) {
            bomb("display-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSmallIcon() {
		boolean required = false;
        String result = getNamedParameter("small-icon");
        if(required && result == null) {
            bomb("small-icon=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLargeIcon() {
		boolean required = false;
        String result = getNamedParameter("large-icon");
        if(required && result == null) {
            bomb("large-icon=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDescription() {
		boolean required = false;
        String result = getNamedParameter("description");
        if(required && result == null) {
            bomb("description=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getName_();
        getClass_();
        getTeiClass();
        getBodyContent();
        getDisplayName();
        getSmallIcon();
        getLargeIcon();
        getDescription();
    }

    public void validateModel() {
        // check uniqueness
    }
}