package org.xdoclet.plugin.web.qtags;

import org.generama.MetadataProvider;

public class TagLibrary {
    public static final String JSP_ATTRIBUTE = JspAttributeTagImpl.NAME;
    public static final String JSP_TAG = JspTagTagImpl.NAME;
    public static final String JSP_VALIDATOR_INIT_PARAM = JspValidatorInitParamTagImpl.NAME;
    public static final String JSP_VARIABLE = JspVariableTagImpl.NAME;
    public static final String WEB_EJB_LOCAL_REF = WebEjbLocalRefTagImpl.NAME;
    public static final String WEB_EJB_REF = WebEjbRefTagImpl.NAME;
    public static final String WEB_ENV_ENTRY = WebEnvEntryTagImpl.NAME;
    public static final String WEB_FILTER_INIT_PARAM = WebFilterInitParamTagImpl.NAME;
    public static final String WEB_FILTER_MAPPING = WebFilterMappingTagImpl.NAME;
    public static final String WEB_FILTER = WebFilterTagImpl.NAME;
    public static final String WEB_LISTENER = WebListenerTagImpl.NAME;
    public static final String WEB_RESOURCE_ENV_REF = WebResourceEnvRefTagImpl.NAME;
    public static final String WEB_RESOURCE_REF = WebResourceRefTagImpl.NAME;
    public static final String WEB_SECURITY_ROLE_REF = WebSecurityRoleRefTagImpl.NAME;
    public static final String WEB_SECURITY_ROLE = WebSecurityRoleTagImpl.NAME;
    public static final String WEB_SERVLET_INIT_PARAM = WebServletInitParamTagImpl.NAME;
    public static final String WEB_SERVLET_MAPPING = WebServletMappingTagImpl.NAME;
    public static final String WEB_SERVLET = WebServletTagImpl.NAME;

    public TagLibrary(MetadataProvider metadataProvider) {
        metadataProvider.getDocletTagFactory().registerTag(JspAttributeTagImpl.NAME, JspAttributeTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(JspTagTagImpl.NAME, JspTagTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(JspValidatorInitParamTagImpl.NAME, JspValidatorInitParamTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(JspVariableTagImpl.NAME, JspVariableTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebEjbLocalRefTagImpl.NAME, WebEjbLocalRefTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebEjbRefTagImpl.NAME, WebEjbRefTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebEnvEntryTagImpl.NAME, WebEnvEntryTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebFilterInitParamTagImpl.NAME, WebFilterInitParamTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebFilterMappingTagImpl.NAME, WebFilterMappingTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebFilterTagImpl.NAME, WebFilterTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebListenerTagImpl.NAME, WebListenerTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebResourceEnvRefTagImpl.NAME, WebResourceEnvRefTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebResourceRefTagImpl.NAME, WebResourceRefTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebSecurityRoleRefTagImpl.NAME, WebSecurityRoleRefTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebSecurityRoleTagImpl.NAME, WebSecurityRoleTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebServletInitParamTagImpl.NAME, WebServletInitParamTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebServletMappingTagImpl.NAME, WebServletMappingTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(WebServletTagImpl.NAME, WebServletTagImpl.class);
    }
}
